package com.tzld.piaoquan.recommend.feature.produce.service;

import com.aliyun.oss.OSS;
import com.aliyun.oss.OSSClientBuilder;
import com.aliyun.oss.model.CopyObjectRequest;
import com.aliyun.oss.model.CopyObjectResult;
import com.aliyun.oss.model.ObjectMetadata;
import com.aliyun.oss.model.StorageClass;
import lombok.extern.slf4j.Slf4j;

import java.io.Serializable;
import java.util.List;

/**
 * @author dyp
 */
@Slf4j
public class OSSService implements Serializable {
    private String accessId = "LTAI5tHMkNaRhpiDB1yWMZPn";
    private String accessKey = "XLi5YUJusVwbbQOaGeGsaRJ1Qyzbui";
    private String endpoint = "https://oss-cn-hangzhou.aliyuncs.com";

    public void transToDeepColdArchive(String bucketName, List<String> objectNames) {
        OSS ossClient = new OSSClientBuilder().build(endpoint, accessId, accessKey);
        for (String objectName : objectNames) {
            try {
                CopyObjectRequest request = new CopyObjectRequest(bucketName, objectName, bucketName, objectName);
                ObjectMetadata objectMetadata = new ObjectMetadata();
                objectMetadata.setHeader("x-oss-storage-class", StorageClass.DeepColdArchive);
                request.setNewObjectMetadata(objectMetadata);
                CopyObjectResult result = ossClient.copyObject(request);
            } catch (Exception e) {
                log.info("copy error {}", objectName, e);
            }
        }
        if (ossClient != null) {
            ossClient.shutdown();
        }
    }
}
